<?php # Listing 3.8 - kalkulator.php #3

// Ta funkcja tworzy przycisk opcji.
// Ma ona jeden argument, value, dodatkowo
// pozwala "zapamiętać" wartość pola.
function create_fuel_radio($value) {

  // Rozpoczynamy generowanie elementu:
  echo '<input type="radio" name="fuel_price" value="' . $value . '"';

  // Sprawdzamy czy jest poprzednia wartość:
  if (isset($_POST['fuel_price']) && ($_POST['fuel_price'] == $value)) {
    echo ' checked="checked"';
  }

  // Kończymy generowanie elementu:
  echo "> $value ";

} // Koniec funkcji create_fuel_radio().

$page_title = 'Kalkulator kosztów podróży!';
include ('includes/naglowek.html');

// Sprawdzamy czy formularz został wysłany.
if ($_SERVER['REQUEST_METHOD'] == 'POST') {

  // Bardzo prosta weryfikacja danych z formularza:
  if (isset($_POST['distance'], $_POST['fuel_price'], $_POST['efficiency']) && 
   is_numeric($_POST['distance']) && is_numeric($_POST['fuel_price']) && is_numeric($_POST['efficiency']) ) {

    // Wyliczamy wyniki:
    $gallons = $_POST['distance'] / $_POST['efficiency'];
    $dollars = $gallons * $_POST['fuel_price'];
    $hours = $_POST['distance']/75;

    // Wyświetlamy wyniki:
    echo '<div class="page-header"><h1>Szacunkowy koszt całkowity</h1></div>
    <p>Całkowity koszt przejechania ' . $_POST['distance'] . ' kilometrów, przy średnim zużyciu ' . $_POST['efficiency'] . ' kilometrów na litr i przy średniej cenie ' . $_POST['fuel_price'] . ' zł za litr, wynosi ' . number_format($dollars, 2) . ' zł. Gdybyś jechał z prędkością 75 kilometrów na godzinę, podróż zajęłaby około ' . number_format($hours, 2) . ' godzin.</p>';

  } else { // Przesłano nieprawidłowe dane.
    echo '<div class="page-header"><h1>Błąd!</h1></div>
    <p class="text-danger">Proszę prawidłowo podać dystans oraz wybrać cenę paliwa i jego zużycie.</p>';
  }

} // Koniec obsługi formularza IF.

// Koniec sekcji PHP i początek formularza HTML:
?>

<div class="page-header"><h1>Kalkulator kosztów podróży</h1></div>
<form action="kalkulator.php" method="post">
  <p>Dystans (w kilometrach): <input type="number" name="distance"  value="<?php if (isset($_POST['distance'])) echo $_POST['distance']; ?>"></p>
  <p>Średnia cena za litr paliwa:
  <?php 
    create_fuel_radio('4.50');
    create_fuel_radio('4.65');
    create_fuel_radio('4.80');
  ?>
  </p>
  <p>Zużycie paliwa: <select name="efficiency">
    <option value="12.5" <?php if (isset($_POST['efficiency']) && ($_POST['efficiency'] == '12.5')) echo ' selected="selected"'; ?>>Duże</option>
    <option value="14.2" <?php if (isset($_POST['efficiency']) && ($_POST['efficiency'] == '14.2')) echo ' selected="selected"'; ?>>Przeciętne</option>
    <option value="16.6" <?php if (isset($_POST['efficiency']) && ($_POST['efficiency'] == '16.6')) echo ' selected="selected"'; ?>>Niskie</option>
    <option value="20"   <?php if (isset($_POST['efficiency']) && ($_POST['efficiency'] == '20')) echo ' selected="selected"'; ?>>Rewelacyjne</option> 
  </select></p>
  <p><input type="submit" name="submit" value="Oblicz!"></p>
</form>

<?php include ('includes/stopka.html'); ?>